UM Java API 6.17.1

- Main Page
- Related Pages
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics Class Reference
Inheritance diagram for com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics:

## Public Member Functions
| LBMImmediateMessageReceiverStatistics ()
| LBMImmediateMessageReceiverStatistics (UMMonAttributes attributes, ReceiverTransport rcvStats) throws LBMException
| LBMImmediateMessageReceiverStatistics (LBMMonitorReceiver lbmmonrcv, ByteBuffer attributeBuffer, ByteBuffer rcvStats) throws LBMException
| LBMImmediateMessageReceiverStatistics (LBMContext lbmctx, int maxStats) throws LBMException
void | refresh (LBMContext lbmctx, int maxStats) throws LBMException
void | dispose ()
int | size ()
int | type () throws LBMException
int | type (int n) throws LBMException
String | typeName () throws LBMException
String | typeName (int n) throws LBMException
String | source () throws LBMException
String | source (int n) throws LBMException
long | bytesReceived () throws LBMException
long | bytesReceived (int n) throws LBMException
long | messagesReceived () throws LBMException
long | messagesReceived (int n) throws LBMException
long | nakPacketsSent () throws LBMException
long | nakPacketsSent (int n) throws LBMException
long | naksSent () throws LBMException
long | naksSent (int n) throws LBMException
long | lost () throws LBMException
long | lost (int n) throws LBMException
long | ncfsIgnored () throws LBMException
long | ncfsIgnored (int n) throws LBMException
long | ncfsShed () throws LBMException
long | ncfsShed (int n) throws LBMException
long | ncfsRetransmissionDelay () throws LBMException
long | ncfsRetransmissionDelay (int n) throws LBMException
long | ncfsUnknown () throws LBMException
long | ncfsUnknown (int n) throws LBMException
long | minimumRecoveryTime () throws LBMException
long | minimumRecoveryTime (int n) throws LBMException
long | meanRecoveryTime () throws LBMException
long | meanRecoveryTime (int n) throws LBMException
long | maximumRecoveryTime () throws LBMException
long | maximumRecoveryTime (int n) throws LBMException
long | minimumNakTransmissions () throws LBMException
long | minimumNakTransmissions (int n) throws LBMException
long | meanNakTransmissions () throws LBMException
long | meanNakTransmissions (int n) throws LBMException
long | maximumNakTransmissions () throws LBMException
long | maximumNakTransmissions (int n) throws LBMException
long | duplicateMessages () throws LBMException
long | duplicateMessages (int n) throws LBMException
long | unrecoveredMessagesWindowAdvance () throws LBMException
long | unrecoveredMessagesWindowAdvance (int n) throws LBMException
long | unrecoveredMessagesNakGenerationTimeout () throws LBMException
long | unrecoveredMessagesNakGenerationTimeout (int n) throws LBMException
long | lbmMessagesReceived () throws LBMException
long | lbmMessagesReceived (int n) throws LBMException
long | lbmRequestsReceived () throws LBMException
long | lbmRequestsReceived (int n) throws LBMException
long | noTopicMessagesReceived () throws LBMException
long | noTopicMessagesReceived (int n) throws LBMException
long | datagramsDroppedIncorrectSize () throws LBMException
long | datagramsDroppedIncorrectSize (int n) throws LBMException
long | datagramsDroppedType () throws LBMException
long | datagramsDroppedType (int n) throws LBMException
long | datagramsDroppedVersion () throws LBMException
long | datagramsDroppedVersion (int n) throws LBMException
long | datagramsDroppedHeader () throws LBMException
long | datagramsDroppedHeader (int n) throws LBMException
long | datagramsDroppedOther () throws LBMException
long | datagramsDroppedOther (int n) throws LBMException
long | datagramsDroppedSID () throws LBMException
long | datagramsDroppedSID (int n) throws LBMException
long | outOfOrder () throws LBMException
long | outOfOrder (int n) throws LBMException
String | displayString (String aString)
String | getApplicationSourceId ()
InetAddress | getSender () throws UnknownHostException
Date | getTimestamp ()
long | getProcessId ()
long | getContextId ()
String | getContextInstance ()
long | getDomainId ()

## Protected Member Functions
void | finalize ()
String | getHexString (byte[] raw)
void | setSender (long ip)
void | setSenderIpv4Address (String ip) throws LBMException
void | setTimestamp (long ts)
void | setApplicationSourceId (String appid)
void | setProcessId (long pid)
void | setContextId (long cid)
void | setContextInstance (String cinst)
void | setDomainId (long did)

## Detailed Description

UM Immediate Message Receiver statistics

This object provides user monitoring with access to statistics of an application being monitored. The user monitoring code can be part of the application being monitored (i.e. the application can be "self-monitoring"), or the monitoring code can be remote, using the lbmmon infrastructure to deliver statistics.

        Note that when stats are sampled, the fields in the structure are not
        necessarily from the same instant in time.  The structure might be
        updated concurrently with it being sampled, and while each structure
        field is atomically read, the field values can be skewed slightly
        across time.

## Constructor & Destructor Documentation

com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.LBMImmediateMessageReceiverStatistics | ( |  | ) |

Instantiate an empty object containing no statistics.

See also
  refresh

com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.LBMImmediateMessageReceiverStatistics | ( | UMMonAttributes | attributes,
|  | ReceiverTransport | rcvStats
| ) |  | throws LBMException

Instantiate object containing the set of receiver transport statistics for a given receiver transport.

Parameters

  attributes | An UMMonAttributesProtos.UMMonAttributes
  rcvStats | An UMSMonProtos.RcvTransportStats

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.LBMImmediateMessageReceiverStatistics | ( | LBMMonitorReceiver | lbmmonrcv,
|  | ByteBuffer | attributeBuffer,
|  | ByteBuffer | rcvStats
| ) |  | throws LBMException

Instantiate object containing the set of receiver transport statistics for a given receiver transport.

Parameters

  lbmmonrcv | LBMMonitorReceiver that received this packet.
  attributeBuffer | A ByteBuffer of packet attributes passed to the passthrough callback
  rcvStats | A ByteBuffer of CSV statistics passed to the passthrough callback

Exceptions

  LBMException | if any error occurred parsing receiver statistics.

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.LBMImmediateMessageReceiverStatistics | ( | LBMContext | lbmctx,
|  | int | maxStats
| ) |  | throws LBMException

Instantiate object containing the aggregate set of statistics for a particular context. This constructor will throw LBMMonitorEInvalException if maxStats is less than the available number of transport statistical sets.

Parameters

  lbmctx | LBMContext object
  maxStats | Maximum number of sources

Exceptions

  LBMException | if any error occurred retrieving statistics.

See also
  refresh

References com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.refresh().

## Member Function Documentation

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.bytesReceived | ( |  | ) | throws LBMException

Number of datagram bytes received (TCP, LBT-RM). The total of lengths of all transport packets, including UM header information. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagram bytes received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.bytesReceived | ( | int | n | ) | throws LBMException

Number of datagram bytes received (TCP, LBT-RM). The total of lengths of all transport packets, including UM header information. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagram bytes received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedHeader | ( |  | ) | throws LBMException

Number of datagrams discarded due to bad header type. These datagrams appeared to be intact, but with an unrecognizable header format. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams discarded due to bad header type

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedHeader | ( | int | n | ) | throws LBMException

Number of datagrams discarded due to bad header type. These datagrams appeared to be intact, but with an unrecognizable header format. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams discarded due to bad header type

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedIncorrectSize | ( |  | ) | throws LBMException

Number of datagrams discarded due to being smaller than the size designated in the datagram's size field. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams discarded due to size

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedIncorrectSize | ( | int | n | ) | throws LBMException

Number of datagrams discarded due to being smaller than the size designated in the datagram's size field. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams discarded due to size

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedOther | ( |  | ) | throws LBMException

Number of unrecognizable datagrams discarded due to reasons other than those determined by the above counts. They could be garbled, or possibly be from foreign or incompatible software at the other end. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams discarded for other reasons

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedOther | ( | int | n | ) | throws LBMException

Number of unrecognizable datagrams discarded due to reasons other than those determined by the above counts. They could be garbled, or possibly be from foreign or incompatible software at the other end. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams discarded for other reasons

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedSID | ( |  | ) | throws LBMException

Number of datagrams discarded due to session ID mismatch. These datagrams appeared to be correctly formed, but with an unmatched/unrecognized session ID field. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams discarded due to session ID mismatch

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedSID | ( | int | n | ) | throws LBMException

Number of datagrams discarded due to session ID mismatch. These datagrams appeared to be correctly formed, but with an unmatched/unrecognized session ID field. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams discarded due to session ID mismatch

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedType | ( |  | ) | throws LBMException

Number of datagrams discarded due to bad packet type. The datagram's type field must match the expectations of the receiver transport. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams discarded due to bad packet type

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedType | ( | int | n | ) | throws LBMException

Number of datagrams discarded due to bad packet type. The datagram's type field must match the expectations of the receiver transport. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams discarded due to bad packet type

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedVersion | ( |  | ) | throws LBMException

Number of datagrams discarded due to version mismatch. The datagram's version field must match the expectations of the receiver transport. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams discarded due to version mismatch

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedVersion | ( | int | n | ) | throws LBMException

Number of datagrams discarded due to version mismatch. The datagram's version field must match the expectations of the receiver transport. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams discarded due to version mismatch

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

void com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.dispose | ( |  | ) |

Free memory associated with this set of statistics.

Referenced by com.latencybusters.lbm.LBMObjectRecycler.close(), and com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.finalize().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.duplicateMessages | ( |  | ) | throws LBMException

Number of duplicate datagrams received (LBT-RM only). A large number can indicate a lossy network, primarily due to other receiver transports requesting retransmissions that this receiver transport has already successfully received. Such duplicates require extra effort for filtering, and this should be investigated. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of duplicate datagrams received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.duplicateMessages | ( | int | n | ) | throws LBMException

Number of duplicate datagrams received (LBT-RM only). A large number can indicate a lossy network, primarily due to other receiver transports requesting retransmissions that this receiver transport has already successfully received. Such duplicates require extra effort for filtering, and this should be investigated. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of duplicate datagrams received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

void com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.finalize | ( |  | ) |
| protected

This method is for internal use only, and is not supported for customer applications.

References com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.dispose().

String com.latencybusters.lbm.LBMStatistics.getApplicationSourceId | ( |  | ) |
| inherited

Retrieve the application source identifier associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Application source ID

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

long com.latencybusters.lbm.LBMStatistics.getContextId | ( |  | ) |
| inherited

Retrieve the sending context ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Context ID

String com.latencybusters.lbm.LBMStatistics.getContextInstance | ( |  | ) |
| inherited

Retrieve the sending context instance associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Context Instance

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

long com.latencybusters.lbm.LBMStatistics.getDomainId | ( |  | ) |
| inherited

Retrieve the sending domain ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Domain ID

References com.latencybusters.lbm.LBMStatistics.getApplicationSourceId(), com.latencybusters.lbm.LBMStatistics.getContextInstance(), com.latencybusters.lbm.LBMStatistics.getSender(), and com.latencybusters.lbm.LBMStatistics.getTimestamp().

long com.latencybusters.lbm.LBMStatistics.getProcessId | ( |  | ) |
| inherited

Retrieve the sending process ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Process ID

InetAddress com.latencybusters.lbm.LBMStatistics.getSender | ( |  | ) | throws UnknownHostException
| inherited

Retrieve the IP sender address associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  InetAddress object corresponding to the statistics' sender IP address

Exceptions

  UnknownHostException | if IP address is of illegal length.

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

Date com.latencybusters.lbm.LBMStatistics.getTimestamp | ( |  | ) |
| inherited

Retrieve the timestamp associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Timestamp Date object

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lbmMessagesReceived | ( |  | ) | throws LBMException

Number of messages or message fragments received over a transport (TCP, LBT-RM). A single datagram may contain one or more messages or a fragment of a larger message. For fragmented messages larger than the transport's maximum size configuration option, this count reflects the number of datagrams used to constitute those messages. Thus, this number is equal to or greater than the datagram counter (messagesReceived, above). This number also includes messages received for which there was no interested receiver, tallied in the noTopicMessagesReceived counter (below). This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of messages or message fragments received over a transport

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lbmMessagesReceived | ( | int | n | ) | throws LBMException

Number of messages or message fragments received over a transport (TCP, LBT-RM). A single datagram may contain one or more messages or a fragment of a larger message. For fragmented messages larger than the transport's maximum size configuration option, this count reflects the number of datagrams used to constitute those messages. Thus, this number is equal to or greater than the datagram counter (messagesReceived, above). This number also includes messages received for which there was no interested receiver, tallied in the noTopicMessagesReceived counter (below). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of messages or message fragments received over a transport

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lbmRequestsReceived | ( |  | ) | throws LBMException

Number of UM request messages received (message type LBM_MSG_REQUEST) (TCP, LBT-RM). This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of UM request messages received (message type LBM_MSG_REQUEST)

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lbmRequestsReceived | ( | int | n | ) | throws LBMException

Number of UM request messages received (message type LBM_MSG_REQUEST) (TCP, LBT-RM). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of UM request messages received (message type LBM_MSG_REQUEST)

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lost | ( |  | ) | throws LBMException

Number of datagrams that have been detected as lost. (LBT-RM only). This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams that have been detected as lost

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lost(), and com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lost | ( | int | n | ) | throws LBMException

Number of datagrams that have been detected as lost. (LBT-RM only). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams that have been detected as lost

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

References com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lost().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.maximumNakTransmissions | ( |  | ) | throws LBMException

Maximum number of times per lost message that a receiver transport transmitted a NAK, i.e., the highest value collected so far (LBT-RM only). A value higher than 1 suggests that there may have been some unrecoverable loss on the network during the sample period. A significantly high value compared to the mean number) implies an isolated incident. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Maximum number of times per lost message that a receiver transport transmitted a NAK transmitted.

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.maximumNakTransmissions | ( | int | n | ) | throws LBMException

Maximum number of times per lost message that a receiver transport transmitted a NAK, i.e., the highest value collected so far (LBT-RM only). A value higher than 1 suggests that there may have been some unrecoverable loss on the network during the sample period. A significantly high value compared to the mean number) implies an isolated incident. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Maximum number of times per lost message that a receiver transport transmitted a NAK

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.maximumRecoveryTime | ( |  | ) | throws LBMException

Maximum time (in milliseconds), i.e., the longest time recorded so far, for a lost message to be recovered (LBT-RM only). If this time is near or equal to the configuration option transport_lbtrm_nak_generation_interval setting, you have likely experienced some level of unrecoverable loss. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Maximum time (in milliseconds) in which loss recovery was accomplished

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.maximumRecoveryTime | ( | int | n | ) | throws LBMException

Maximum time (in milliseconds), i.e., the longest time recorded so far, for a lost message to be recovered (LBT-RM only). If this time is near or equal to the configuration option transport_lbtrm_nak_generation_interval setting, you have likely experienced some level of unrecoverable loss. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Maximum time (in milliseconds) in which loss recovery was accomplished

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.meanNakTransmissions | ( |  | ) | throws LBMException

Mean number of times per lost message that a receiver transport transmitted a NAK (LBT-RM only). Ideally this should be at or near 1. A higher value indicates a lossy network. This is an exponentially weighted moving average (weighted to more recent) for accumulated NAKs per lost message. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Mean number of times per lost message that a receiver transport transmitted a NAK

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.meanNakTransmissions | ( | int | n | ) | throws LBMException

Mean number of times per lost message that a receiver transport transmitted a NAK (LBT-RM only). Ideally this should be at or near 1. A higher value indicates a lossy network. This is an exponentially weighted moving average (weighted to more recent) for accumulated NAKs per lost message. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Mean number of times per lost message that a receiver transport transmitted a NAK

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.meanRecoveryTime | ( |  | ) | throws LBMException

Mean time (in milliseconds) in which loss recovery was accomplished (LBT-RM only). This is an exponentially weighted moving average (weighted to more recent) for accumulated measured recovery times. Ideally this field should be as close to your minimum recovery time (nak_stm_min, above) as possible. High mean recovery times indicate a lossy network. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Mean time (in milliseconds) in which loss recovery was accomplished

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.meanRecoveryTime | ( | int | n | ) | throws LBMException

Mean time (in milliseconds) in which loss recovery was accomplished (LBT-RM only). This is an exponentially weighted moving average (weighted to more recent) for accumulated measured recovery times. Ideally this field should be as close to your minimum recovery time (nak_stm_min, above) as possible. High mean recovery times This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Mean time (in milliseconds) in which loss recovery was accomplished

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.messagesReceived | ( |  | ) | throws LBMException

Number of datagrams received (LBT-RM only). Depending on batching settings, a single LBT-RM datagram may contain one or more messages, or a fragment of a larger message. With LBT-RM, larger messages are split into fragment sizes limited by configuration option transport_lbtrm_datagram_max_size (default 8KB).

This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.messagesReceived | ( | int | n | ) | throws LBMException

Number of datagrams received (LBT-RM only). Depending on batching settings, a single LBT-RM datagram may contain one or more messages, or a fragment of a larger message. With LBT-RM, larger messages are split into fragment sizes limited by configuration option transport_lbtrm_datagram_max_size (default 8KB).

This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.minimumNakTransmissions | ( |  | ) | throws LBMException

Minimum number of times per lost message that a receiver transport transmitted a NAK, i.e., the lowest value collected so far (LBT-RM only). A value greater than 1 indicates a chronically lossy network. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Minimum number of times per lost message that a receiver transport transmitted a NAK.

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.minimumNakTransmissions | ( | int | n | ) | throws LBMException

Minimum number of times per lost message that a receiver transport transmitted a NAK, i.e., the lowest value collected so far (LBT-RM only). A value greater than 1 indicates a chronically lossy network. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Minimum number of times per lost message that a receiver transport transmitted a NAK.

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.minimumRecoveryTime | ( |  | ) | throws LBMException

Minimum time (in milliseconds), i.e., the shortest time recorded so far, for a lost message to be recovered (LBT-RM only). If this time is greater than configuration option transport_lbtrm_nak_backoff_interval, it may be taking multiple NAKs to initiate retransmissions, indicating a lossy network. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Minimum time (in milliseconds) in which loss recovery was accomplished

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.minimumRecoveryTime | ( | int | n | ) | throws LBMException

Minimum time (in milliseconds), i.e., the shortest time recorded so far, for a lost message to be recovered (LBT-RM only). If this time is greater than configuration option transport_lbtrm_nak_backoff_interval, it may be taking multiple NAKs to initiate retransmissions, indicating a lossy network. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Minimum time (in milliseconds) in which loss recovery was accomplished

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.nakPacketsSent | ( |  | ) | throws LBMException

Number of NAK packets sent by the receiver transport (LBT-RM only). UM batches NAKs into NAK packets to save network bandwidth. This should always be less than or equal to the number of individual NAKs sent (naksSent, below). This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of NAK packets sent by the receiver transport

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.nakPacketsSent | ( | int | n | ) | throws LBMException

Number of NAK packets sent by the receiver transport (LBT-RM only). UM batches NAKs into NAK packets to save network bandwidth. This should always be less than or equal to the number of individual NAKs sent (naksSent, below). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NAK packets sent by the receiver transport

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.naksSent | ( |  | ) | throws LBMException

Number of individual NAKs sent by the receiver transport (LBT-RM only). This may differ from the tally of lost datagrams (below) due to reasons such as

- Other receiver transports may have already sent a NAK for the same lost datagram, resulting in a retransmitted lost datagram (or an NCF) to arrive at this receiver transport before it has a chance to issue a NAK, or
- During periods of heavy loss, receiver transports may be forced to issue multiple NAKs per lost datagram (controlled by configuration options transport_lbtrm_nak_generation_interval and transport_lbtrm_nak_backoff_interval) until either the retransmission is received or the datagram is declared unrecovered (which may ultimately lead to UM delivering an LBM_MSG_UNRECOVERABLE_LOSS notification to the receiver application).

This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of individual NAKs sent by the receiver transport.

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.naksSent | ( | int | n | ) | throws LBMException

Number of individual NAKs sent by the receiver transport (LBT-RM only). This may differ from the tally of lost datagrams (below) due to reasons such as

- Other receiver transports may have already sent a NAK for the same lost datagram, resulting in a retransmitted lost datagram (or an NCF) to arrive at this receiver transport before it has a chance to issue a NAK, or
- During periods of heavy loss, receiver transports may be forced to issue multiple NAKs per lost datagram (controlled by configuration options transport_lbtrm_nak_generation_interval and transport_lbtrm_nak_backoff_interval) until either the retransmission is received or the datagram is declared unrecovered (which may ultimately lead to UM delivering an LBM_MSG_UNRECOVERABLE_LOSS notification to the receiver application).

This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of individual NAKs sent by the receiver transport.

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsIgnored | ( |  | ) | throws LBMException

Number of NCFs received from a source transport with reason code "ignored" (LBT-RM only). If a source transport receives a NAK for a datagram that it has recently retransmitted, it sends an "NCF ignored" and does not retransmit. How "recently" is determined by the configuration option source transport_lbtrm_ignore_interval (default 500ms). If this count is high, a receiver transport may be having trouble receiving retransmissions, or the ignore interval may be set too long. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of NCFs received from a source transport with the reason code set to "ignored".

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsIgnored | ( | int | n | ) | throws LBMException

Number of NCFs received from a source transport with reason code "ignored" (LBT-RM only). If a source transport receives a NAK for a datagram that it has recently retransmitted, it sends an "NCF ignored" and does not retransmit. How "recently" is determined by the configuration option source transport_lbtrm_ignore_interval (default 500ms). If this count is high, a receiver transport may be having trouble receiving retransmissions, or the ignore interval may be set too long. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NCFs received from a source transport with the reason code set to "ignored".

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsRetransmissionDelay | ( |  | ) | throws LBMException

Number of NCFs received with reason code "rx_delay" (LBT-RM only). When a source transport's retransmit rate limiter prevents it from immediately retransmitting any more lost datagrams, it responds to a NAK by sending an "NCF rx_delay", then queues the retransmission for a later send. The receiver transport should wait for the retransmission and not immediately send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of NCFs that have been received with the reason code set to "rx_delay".

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsRetransmissionDelay | ( | int | n | ) | throws LBMException

Number of NCFs received with reason code "rx_delay" (LBT-RM only). When a source transport's retransmit rate limiter prevents it from immediately retransmitting any more lost datagrams, it responds to a NAK by sending an "NCF rx_delay", then queues the retransmission for a later send. The receiver transport should wait for the retransmission and not immediately send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NCFs received with reason code "rx_delay"

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsShed | ( |  | ) | throws LBMException

Number of NCFs received with reason code "shed" (LBT-RM only). When a source transport's retransmit queue and rate limiter are both at maximum, it responds to a NAK by sending an "NCF shed", and does not retransmit. The receiver transport should wait, then send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of NCFs that have been received with the reason code set to "shed"

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsShed | ( | int | n | ) | throws LBMException

Number of NCFs received with reason code "shed" (LBT-RM only). When a source transport's retransmit queue and rate limiter are both at maximum, it responds to a NAK by sending an "NCF shed", and does not retransmit. The receiver transport should wait, then send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NCFs that have been received with the reason code set to "shed"

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsUnknown | ( |  | ) | throws LBMException

Number of NCFs received with reason code "unknown" (LBT-RM only). These are NCFs with a reason code this receiver transport does not recognize. After a delay (set by configuration option transport_lbtrm_nak_suppress_interval (default 1000ms), it resends the NAK. This counter should never be greater than 0 unless applications linked with different versions of Ultra Messaging software coexist on the same network. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of NCFs that have been received with the reason code set to "unknown".

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsUnknown | ( | int | n | ) | throws LBMException

Number of NCFs received with reason code "unknown" (LBT-RM only). These are NCFs with a reason code this receiver transport does not recognize. After a delay (set by configuration option transport_lbtrm_nak_suppress_interval (default 1000ms), it resends the NAK. This counter should never be greater than 0 unless applications linked with different versions of Ultra Messaging software coexist on the same network. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NCFs that have been received with the reason code set to "unknown".

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.noTopicMessagesReceived | ( |  | ) | throws LBMException

Number of messages received that were not for a topic of interest to the receiver (TCP, LBT-RM). A high value (relative to, or approaching lbmMessagesReceived above) indicates more CPU time required to filter out uninteresting topics, in which case, consider reconfiguring sources to filter more aggressively at the transport layer. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of messages received that were not for a topic of interest to the receiver

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.noTopicMessagesReceived | ( | int | n | ) | throws LBMException

Number of messages received that were not for a topic of interest to the receiver (TCP, LBT-RM). A high value (relative to, or approaching lbmMessagesReceived above) indicates more CPU time required to filter out uninteresting topics, in which case, consider reconfiguring sources to filter more aggressively at the transport layer. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of messages received that were not for a topic of interest to the receiver

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder | ( |  | ) | throws LBMException

Number of out-of-order datagrams received. A datagram is counted as out of order if it fills a previously detected sequence gap, but is not a retransmission. Note that if the duplicates counter duplicate_data, above) increases along with this statistic, this implies the arrivals of retransmitted datagrams before their originals. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of out-of-order datagrams received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder | ( | int | n | ) | throws LBMException

Number of out-of-order datagrams received. A datagram is counted as out of order if it fills a previously detected sequence gap, but is not a retransmission. Note that if the duplicates counter duplicate_data, above) increases along with this statistic, this implies the arrivals of retransmitted datagrams before their originals. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of out-of-order datagrams received

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

References com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.bytesReceived(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedHeader(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedIncorrectSize(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedOther(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedType(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.datagramsDroppedVersion(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.duplicateMessages(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lbmMessagesReceived(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lbmRequestsReceived(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.lost(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.maximumNakTransmissions(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.maximumRecoveryTime(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.meanNakTransmissions(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.meanRecoveryTime(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.messagesReceived(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.minimumNakTransmissions(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.minimumRecoveryTime(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.nakPacketsSent(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.naksSent(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsIgnored(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsRetransmissionDelay(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsShed(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.ncfsUnknown(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.noTopicMessagesReceived(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.source(), com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP, com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.type(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.typeName(), com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.unrecoveredMessagesNakGenerationTimeout(), and com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.unrecoveredMessagesWindowAdvance().

void com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.refresh | ( | LBMContext | lbmctx,
|  | int | maxStats
| ) |  | throws LBMException

Refresh the aggregate set of statistics for a particular context. This method will throw LBMMonitorEInvalException if maxStats is less than the available number of transport statistical sets.

Parameters

  lbmctx | LBMContext object associated with statistics to be retrieved.
  maxStats | Maximum number of sources.

Exceptions

  LBMException | if any error occurred retrieving statistics.

Referenced by com.latencybusters.lbm.LBMContext.getImmediateMessageReceiverStatistics(), and com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.LBMImmediateMessageReceiverStatistics().

int com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.size | ( |  | ) |

Number of transport statistical sets encapsulated within this object

Returns
  Statistical set size

String com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.source | ( |  | ) | throws LBMException

Source of transport as a string. This method returns a value from the first set of statistics encapsulated within this object. The string format depends on transport type and is described under LBMTransportSourceInfo.

See also
  LBMTransportSourceInfo

Returns
  Source of transport as a string

Exceptions

  LBMException | if any error occurred retrieving statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder(), and com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.source().

String com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.source | ( | int | n | ) | throws LBMException

Source of transport as a string. This method returns a value from the nth set of statistics encapsulated within this object. The string format depends on transport type and is described under LBMTransportSourceInfo.

See also
  LBMTransportSourceInfo

Parameters

  n | Statistics set index

Returns
  Source of transport as a string

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

References com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.source().

int com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.type | ( |  | ) | throws LBMException

Transport type (TCP, LBT-RM, etc.). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Transport type

Exceptions

  LBMException | if any error occurred retrieving statistics.

See also
  LBM

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder(), and com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.type().

int com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.type | ( | int | n | ) | throws LBMException

Transport type (TCP, LBT-RM, etc.). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Transport type

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

See also
  LBM

References com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.type().

String com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.typeName | ( |  | ) | throws LBMException

Transport type name (TCP, LBT-RM, etc.). This method returns a value from the first set of statistics encapsulated within this object

Returns
  Transport type name

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

String com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.typeName | ( | int | n | ) | throws LBMException

Transport type name (TCP, LBT-RM, etc.). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Transport type name

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.unrecoveredMessagesNakGenerationTimeout | ( |  | ) | throws LBMException

Number of LBT-RM datagrams unrecovered due to a retransmission not received within the NAK generation interval (LBT-RM only). This is set by configuration option transport_lbtrm_nak_generation_interval; default 10,000ms. Note: Receivers for these messages' topics will also report related messages as unrecoverable, with LBM_MSG_UNRECOVERABLE_LOSS for an individual message and LBM_MSG_UNRECOVERABLE_LOSS_BURST for a burst loss event. However, it is possible for these application-level message declarations to occur even without increments to this counter, as the transport is unaware of the topic content of messages and may still be trying to deliver related lost packets. This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of LBT-RM datagrams unrecovered due to a retransmission not received within the NAK generation interval

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.unrecoveredMessagesNakGenerationTimeout | ( | int | n | ) | throws LBMException

Number of LBT-RM datagrams unrecovered due to a retransmission not received within the NAK generation interval (LBT-RM only). This is set by configuration option transport_lbtrm_nak_generation_interval; default 10,000ms. Note: Receivers for these messages' topics will also report related messages as unrecoverable, with LBM_MSG_UNRECOVERABLE_LOSS for an individual message and LBM_MSG_UNRECOVERABLE_LOSS_BURST for a burst loss event. However, it is possible for these application-level message declarations to occur even without increments to this counter, as the transport is unaware of the topic content of messages and may still be trying to deliver related lost packets. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of LBT-RM datagrams unrecovered due to a retransmission not received within the NAK generation interval

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.unrecoveredMessagesWindowAdvance | ( |  | ) | throws LBMException

Number of datagrams unrecovered (LBM_MSG_UNRECOVERABLE_LOSS delivered to receiver application) due to transmission window advance (LBT-RM only). This means that the message was no longer in the source-side transmission window and therefore not retransmitted. The window size is set by transport configuration option lbtrm_transmission_window_size (default 24MB). This method returns a value from the first set of statistics encapsulated within this object.

Returns
  Number of datagrams unrecovered due to transmission window advance

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

Referenced by com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.outOfOrder().

long com.latencybusters.lbm.LBMImmediateMessageReceiverStatistics.unrecoveredMessagesWindowAdvance | ( | int | n | ) | throws LBMException

Number of datagrams unrecovered (LBM_MSG_UNRECOVERABLE_LOSS delivered to receiver application) due to transmission window advance (LBT-RM only). This means that the message was no longer in the source-side transmission window and therefore not retransmitted. The window size is set by transport configuration option lbtrm_transmission_window_size (default 24MB). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams unrecovered due to transmission window advance

Exceptions

  LBMException | if any error occurred retrieving receiver statistics.

The documentation for this class was generated from the following file:

- LBMImmediateMessageReceiverStatistics.java